package com.loafle.overflow.crawler.mongo;

import com.loafle.overflow.crawler.Crawler;
import com.loafle.overflow.crawler.config.Config;
import com.loafle.overflow.crawler.config.Item;

import com.loafle.overflow.crawler.result.OFResultSet;
import com.loafle.overflow.crawler.result.OFResultSetCol;
import com.mongodb.MongoClient;
import com.mongodb.MongoClientOptions;
import com.mongodb.ServerAddress;
import com.mongodb.client.MongoDatabase;
import org.bson.Document;

import java.util.*;


public class MongoCrawler extends Crawler {

    public Object collectMetric(Config c) throws Exception {

        MongoClient mongoClient = null;
//        Map<String, Object> returnMap = new HashMap<String, Object>();

        String dataBaseName = null;
        String statusCommand = null;

        String targetIP = c.getTarget().getConnection().getIp();
        short targetPort = Short.parseShort(c.getTarget().getConnection().getPort());
        List<OFResultSet> ofResultSets = null;
        try {

            mongoClient = new MongoClient(new ServerAddress(targetIP, targetPort),
                    MongoClientOptions.builder()
                            .serverSelectionTimeout(1000)
                            .connectTimeout(1000)
                            .socketTimeout(1000).build()
            );

            ofResultSets = new ArrayList<>();
            OFResultSet ofResultSet = null;
            List<Item> items = c.getItems();
            List<String> row = null;
            for (Item item : items) {

                ofResultSet = OFResultSet.newInstance(item);
                Map<String,Integer> metaMap = ofResultSet.getMeta();
                row = new ArrayList<>(Arrays.asList(new String[metaMap.size()]));





                dataBaseName = (String)item.getQueryInfo().getExtend().get("dataBaseName");
                statusCommand = (String)item.getQueryInfo().getExtend().get("statusCommand");

                MongoDatabase database = mongoClient.getDatabase(dataBaseName);
                Document serverStatus = database.runCommand(new Document(statusCommand, 1));


                Map<String, String> re = (Map<String, String>)serverStatus.get(item.getQueryInfo().getQuery());

                for (Map.Entry<String, Integer> info : metaMap.entrySet()) {
                    row.set(info.getValue().intValue(), String.valueOf(re.get(info.getKey())));
                }

                ofResultSet.addRow(row);
                ofResultSets.add(ofResultSet);

            }
        }catch (Exception e) {
            throw e;
        }finally {
            if (mongoClient != null) {
                mongoClient.close();
            }
        }
        return ofResultSets;
    }

    @Override
    public Object getInternal(Config config) throws Exception {
        return this.collectMetric(config);
    }
}